hdu 1541 Stars (线段树)

来源:互联网 发布:淘宝儿童图书商城 编辑:程序博客网 时间:2024/05/17 20:26
Problem Description
Astronomers often examine star maps where stars are represented by points on a plane and each star has Cartesian coordinates. Let the level of a star be an amount of the stars that are not higher and not to the right of the given star. Astronomers want to know the distribution of the levels of the stars.



For example, look at the map shown on the figure above. Level of the star number 5 is equal to 3 (it's formed by three stars with a numbers 1, 2 and 4). And the levels of the stars numbered by 2 and 4 are 1. At this map there are only one star of the level 0, two stars of the level 1, one star of the level 2, and one star of the level 3.

You are to write a program that will count the amounts of the stars of each level on a given map.
 

Input
The first line of the input file contains a number of stars N (1<=N<=15000). The following N lines describe coordinates of stars (two integers X and Y per line separated by a space, 0<=X,Y<=32000). There can be only one star at one point of the plane. Stars are listed in ascending order of Y coordinate. Stars with equal Y coordinates are listed in ascending order of X coordinate.
 

Output
The output should contain N lines, one number per line. The first line contains amount of stars of the level 0, the second does amount of stars of the level 1 and so on, the last line contains amount of stars of the level N-1.
 

Sample Input
51 15 17 13 35 5
 

Sample Output
12110
 

题意:给n个星星,每个星星按y坐标从小到大,y一样x从小到大输入,然后每个星星的做下区域每包含一个星星(不包括自己),该星星就升一级;最后求等级0~n-1的星星的个数。
思路:由于给出的数据是按Y坐标从小到大,所以我们只需要利用线段树在每插入一个x查询之前有多少小于它的数即可;
代码:
#include<cstdio>#include<algorithm>#include<cstring>using namespace std;const int N=35000;int a[N],b[N],c[N],vis[N];struct node{    int l,r,len;}str[N*3];int find(int x,int len){    int l=0,r=len;    while(l<r)    {        int temp=(l+r)/2;        if(x<=a[temp])            r=temp;        else            l=temp+1;    }    return l;}void build(int l,int r,int n){    str[n].l=l;    str[n].r=r;    str[n].len=0;    if(l==r)        return;    int temp=(l+r)/2;    build(l,temp,2*n);    build(temp+1,r,2*n+1);}void insert(int x,int n,int sum){    if(str[n].l==str[n].r)    {        if(str[n].len)            sum+=str[n].len;        str[n].len++;        vis[sum]++;        return;    }    int temp=(str[n].l+str[n].r)/2;    if(x<=temp)        insert(x,2*n,sum);    else        insert(x,2*n+1,sum+str[2*n].len);    str[n].len=str[2*n].len+str[2*n+1].len;}int main(){    int n;    while(~scanf("%d",&n))    {        for(int i=0;i<n;i++)        {            scanf("%d%d",&a[i],&b[i]);            c[i]=a[i];        }        memset(vis,0,sizeof(vis));        sort(a,a+n);        int len=unique(a,a+n)-a;        for(int i=0;i<n;i++)            c[i]=find(c[i],len)+1;        build(1,len,1);        for(int i=0;i<n;i++)            insert(c[i],1,0);        for(int i=0;i<n;i++)            printf("%d\n",vis[i]);    }}



0 0
原创粉丝点击